stages:
  - lint
  - test
  - pages

variables:
  CARGO_HOME: $CI_PROJECT_DIR/cargo
  APT_CACHE_DIR: $CI_PROJECT_DIR/apt

check:
  image: "rustdocker/rustfmt_clippy:stable"
  stage: "lint"
  script:
    - rustc --version
    - cargo --version
    - cargo fmt --all -- --check
    - cargo clippy -- -D warnings
    - cargo install cargo-audit
    - cargo audit

test:
  image: "rustdocker/rustfmt_clippy:stable"
  stage: test
  script:
    - rustc --version
    - cargo --version
    - mkdir -p /run/user/$UID
    - sed s/UID/$UID/ gitlab/dbus-session.conf > /tmp/dbus-session.conf
    - apt-get --allow-unauthenticated update -yq
    - apt-get install -o dir::cache::archives="$APT_CACHE_DIR" -y  --allow-unauthenticated dbus
    - dbus-run-session --config-file /tmp/dbus-session.conf -- cargo test --verbose -- --skip fdpass_systemd
    - dbus-run-session --config-file /tmp/dbus-session.conf -- cargo test --verbose --all-features -- --skip fdpass_systemd

cache:
  paths:
    - apt/
    - cargo/
    - target/

pages:
  image: "rustlang/rust:nightly"
  stage: pages
  before_script:
    - export PATH="$PATH:$CARGO_HOME/bin"
    - mdbook --version || cargo install --debug mdbook
  script:
    - mkdir public
    - mdbook build book
    - cp -r ./book/book/* ./public
    - find $PWD/public | grep "\.html\$"

  artifacts:
    paths:
      - public

  only:
    - master
